// 秒数转为倒计时方式的字符串
var secondToCountdown = function (second, zh_CN, justDayOver24h) {
    if (justDayOver24h === void 0) { justDayOver24h = true; }
    var _second = second < 0 ? 0 : second;
    var HOUR = 3600;
    var H24 = 24;
    var S60 = 60;
    // 如果超过1天，仅显示天
    if (justDayOver24h) {
        if (Math.floor(_second / (HOUR * H24)) > 0) {
            return Math.floor(_second / (HOUR * H24)) + "\u5929";
        }
    }
    var h = ("000" + Math.floor(_second / HOUR)).substr(-2);
    var m = ("000" + Math.floor((_second / S60) % S60)).substr(-2);
    var s = ("000" + Math.floor(_second % S60)).substr(-2);
    // 如果使用中文
    if (zh_CN) {
        if (h === '00') {
            return m + "\u5206" + s + "\u79D2";
        }
        return h + "\u65F6" + m + "\u5206" + s + "\u79D2";
    }
    return h + ":" + m + ":" + s;
};
var dateFormat = function (date, fmt) {
    var o = {
        'M+': date.getMonth() + 1,
        'd+': date.getDate(),
        'h+': date.getHours(),
        'm+': date.getMinutes(),
        's+': date.getSeconds(),
        'q+': Math.floor((date.getMonth() + 3) / 3),
        S: date.getMilliseconds(),
    };
    var format = fmt;
    if (/(y+)/.test(fmt)) {
        format = fmt.replace(RegExp.$1, String(date.getFullYear()).substr(4 - RegExp.$1.length));
    }
    if (/(wk)/.test(fmt)) {
        var wks = '日一二三四五六'.split('');
        format = fmt.replace(RegExp.$1, wks[date.getDay()]);
    }
    for (var k in o) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length === 1
                ? o[k]
                : ("00" + o[k]).substr(String(o[k]).length));
        }
    }
    return format;
};
// 时间差，单位为小时
var offsetHours = function (date1, date2) {
    var NUM = 3600000;
    return Math.ceil((date2.valueOf() - date1.valueOf()) / NUM);
};
// 将时间差转为文字方式
var offsetDays = function (date1, date2) {
    var DAYHOURS = 24;
    var offset = Math.abs(offsetHours(date1, date2));
    if (offset === 0) {
        return '';
    }
    if (offset < DAYHOURS) {
        return offset + "\u5C0F\u65F6";
    }
    if (offset % DAYHOURS === 0) {
        return offset / DAYHOURS + "\u5929";
    }
    return Math.floor(offset / DAYHOURS) + "\u5929 " + offset % DAYHOURS + "\u5C0F\u65F6";
};
// 将字符串20190101093000 转换为时间格式
var stringToDate = function (val) {
    if (!val || !/[0-9]+/.test(val)) {
        throw Error('invalid date');
    }
    var LEN = 14;
    var _str = val;
    if (_str.length === 4) {
        _str = _str + "0101"; // 如果只有年，把月和日补1，即 2019 => 20190101
    }
    else if (_str.length === 6) {
        // 如果只有年月，把日补1，即 201901 => 20190101
        _str = _str + "01";
    }
    _str = (_str + "00000000000000").substr(0, LEN);
    var v = _str.replace(/(^\d{4}|\d{2})/gi, function (res) { return res + ","; }).split(',', 6);
    v[1] = Number(v[1]) - 1;
    return new Date(v[0], v[1], v[2], v[3], v[4], v[5]);
};
export { offsetHours, offsetDays, stringToDate, dateFormat, secondToCountdown };
