import * as React from 'react';
import './style.scss';
interface ILayoutProps {
    className?: string;
    useTopSafeArea?: boolean;
    topSafeAreaColor?: string;
    useBottomSafeArea?: boolean;
    bottomSafeAreaColor?: string;
    [otherProps: string]: any;
}
interface ILayout {
    Header: React.FC<IHeaderProps>;
    Body: React.ComponentClass<IBodyProps>;
    Footer: React.FC<IFooterProps>;
}
declare const Layout: React.FC<ILayoutProps> & ILayout;
interface IBodyProps {
    loading?: boolean;
    errorInfo?: string;
    className?: string;
    onScroll?: (event: React.UIEvent<HTMLDivElement>) => void;
    skeleton?: React.ReactChild;
    skeletonRepeat?: number;
    onReachBottom?: {
        disabled: boolean;
        content?: React.ReactChild;
        handler: () => void;
    };
    [otherProps: string]: any;
}
interface IFooterProps {
    className?: string;
    visible?: boolean;
    [otherProps: string]: any;
}
interface IHeaderProps {
    className?: string;
    ghost?: boolean;
    addonBefore?: React.ReactNode;
    onBackClick?: ((event: React.MouseEvent<HTMLAnchorElement>) => void) | boolean;
    onCloseClick?: ((event: React.MouseEvent<HTMLAnchorElement>) => void) | boolean;
    title?: string;
    addonAfter?: React.ReactNode;
    addonBottom?: React.ReactNode;
    borderType?: 'border' | 'shadow' | 'none';
    headline?: boolean;
    hideInAlipay?: boolean;
    hideInAlipayMP?: boolean;
    hideInApp?: boolean;
    tabs?: React.ReactNode;
    homepage?: ((event: React.MouseEvent<HTMLAnchorElement>) => void) | string | boolean;
    useSafeArea?: boolean;
    [otherProps: string]: any;
}
export default Layout;
